Open In App

Java Program for Minimum number of jumps to reach end

Write a Java program for a given array arr[] where each element represents the maximum number of steps that can be made forward from that index. The task is to find the minimum number of jumps to reach the end of the array starting from index 0.
If an element is 0, then cannot move through that element.

Examples:



Input: arr[] = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9}
Output: 3 (1-> 3 -> 9 -> 9)
Explanation: Jump from 1st element to 2nd element as there is only 1 step. Now there are three options 5, 8 or 9. If 8 or 9 is chosen then the end node 9 can be reached. So 3 jumps are made.

Input: arr[] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}
Output: 10
Explanation: In every step a jump is needed so the count of jumps is 10.



Java Program for Minimum number of jumps to reach end using Recursion:

Start from the first element and recursively call for all the elements reachable from the first element. The minimum number of jumps to reach end from first can be calculated using the minimum value from the recursive calls. 

minJumps(start, end) = 1 + Min(minJumps(k, end)) for all k reachable from start.

Step-by-step approach:

Below is the implementation of the above approach:




// Java program to find Minimum
// number of jumps to reach end
import java.io.*;
import java.util.*;
 
class GFG {
    // Returns minimum number of
    // jumps to reach arr[h] from arr[l]
    static int minJumps(int arr[], int l, int h)
    {
        // Base case: when source
        // and destination are same
        if (h == l)
            return 0;
 
        // When nothing is reachable
        // from the given source
        if (arr[l] == 0)
            return Integer.MAX_VALUE;
 
        // Traverse through all the points
        // reachable from arr[l]. Recursively
        // get the minimum number of jumps
        // needed to reach arr[h] from these
        // reachable points.
        int min = Integer.MAX_VALUE;
        for (int i = l + 1; i <= h && i <= l + arr[l];
            i++) {
            int jumps = minJumps(arr, i, h);
            if (jumps != Integer.MAX_VALUE
                && jumps + 1 < min)
                min = jumps + 1;
        }
        return min;
    }
 
    // Driver code
    public static void main(String args[])
    {
        int arr[] = { 1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9 };
        int n = arr.length;
        System.out.print(
            "Minimum number of jumps to reach end is "
            + minJumps(arr, 0, n - 1));
    }
}
 
// This code is contributed by Sahil_Bansall

Output
Minimum number of jumps to reach end is 3

Time complexity: O(nn). There are maximum n possible ways to move from an element. So the maximum number of steps can be nn.
Auxiliary Space: O(n). For recursion call stack.

Java Program for Minimum number of jumps to reach end Using Dynamic Programming (Memoization):

It can be observed that there will be overlapping subproblems. 
For example in array, arr[] = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9} minJumps(3, 9) will be called two times as arr[3] is reachable from arr[1] and arr[2]. So this problem has both properties (optimal substructure and overlapping subproblems) of Dynamic Programming.

Step-by-step approach:

Below is the implementation of the above approach:




import java.util.Arrays;
 
public class Geek {
 
    // Helper function to find the minimum jumps required to reach the end
    private static int jump(int[] nums, int idx, int end, int[] memo) {
 
        // We reached the end. No jumps to make further
        if (idx == end)
            return 0;
 
        if (memo[idx] != -1)
            return memo[idx];
 
        int min_jumps = Integer.MAX_VALUE - 1;
 
        // We will try to make all possible jumps from the current index
        // and select the minimum of those.
        // It does not matter if we try from 1 to nums[idx] or from nums[idx] to 1.
        for (int j = nums[idx]; j >= 1; --j) {
            // If we make this jump 'j' distance away from idx,
            // do we overshoot?
            // If we land within the nums, we will test further.
            if (idx + j <= end) {
                // Make a jump to idx + j index and explore further,
                // then update min_jumps with the minimum jumps
                // we made to reach the end while trying all possible
                // nums[idx] jumps from the current index.
                min_jumps = Math.min(min_jumps, 1 + jump(nums, idx + j, end, memo));
            }
        }
 
        return memo[idx] = min_jumps;
    }
 
    // Memoization
    private static int minJumps(int[] nums) {
        int[] memo = new int[nums.length];
        Arrays.fill(memo, -1);
        return jump(nums, 0, nums.length - 1, memo);
    }
 
    public static void main(String[] args) {
        int[] arr = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9};
        System.out.println(minJumps(arr));
    }
}

Output
3

Time complexity: O(n2)
Auxiliary Space: O(n), because of recursive stack space and memo array.

Java Program for Minimum number of jumps to reach end using Dynamic Programming (Tabulation):

Step-by-step approach:

Below is the implementation of the above approach:




// JAVA Code for Minimum number
// of jumps to reach end
 
import java.io.*;
 
class GFG {
 
    private static int minJumps(int[] arr, int n)
    {
        // jumps[n-1] will hold the
        int jumps[] = new int[n];
        // result
        int i, j;
 
        // if first element is 0,
        if (n == 0 || arr[0] == 0)
            return Integer.MAX_VALUE;
        // end cannot be reached
 
        jumps[0] = 0;
 
        // Find the minimum number of jumps to reach arr[i]
        // from arr[0], and assign this value to jumps[i]
        for (i = 1; i < n; i++) {
            jumps[i] = Integer.MAX_VALUE;
            for (j = 0; j < i; j++) {
                if (i <= j + arr[j]
                    && jumps[j] != Integer.MAX_VALUE) {
                    jumps[i]
                        = Math.min(jumps[i], jumps[j] + 1);
                    break;
                }
            }
        }
        return jumps[n - 1];
    }
 
    // driver program to test above function
    public static void main(String[] args)
    {
        int arr[] = { 1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9 };
 
        System.out.println(
            "Minimum number of jumps to reach end is : "
            + minJumps(arr, arr.length));
    }
}
 
// This code is contributed by Arnav Kr. Mandal.

Output
Minimum number of jumps to reach end is 3

Time Complexity: O(n2)
Auxiliary Space: O(n), since n extra space has been taken.

Please refer complete article on Minimum number of jumps to reach end for more details!


Article Tags :